#include <8051.h>
#include <stdio.h>

#define  E    P1_BITS.B2
#define  RW   P1_BITS.B1
#define  RS   P1_BITS.B0

char lcdbuf[16];

void init_lcd(void);
void gotolcd(unsigned char);
void write_ins(unsigned char);
void write_data(unsigned char);
void printlcd(void);
void delay(char);

void interrupt timer1(void);

unsigned int speed; 
unsigned int ms;

void main(void)
{
  delay(10);
  init_lcd();
  
  P3 = 0xFE;
  ET1 = 1;
  TMOD = 0x15;

  while(1)
  {
    TH1  = 0xF3;
    TL1  = 0xFF;
    TH0  = 0x00;
    TL0  = 0x00;

    ms = 0;
    TR0 = 1;
    TR1 = 1;
    EA  = 1;
  
    while(ms < 500) {}
  
    EA  = 0;
    TR0 = 0;
    TR1 = 0;
    
	speed = TH0;
	speed <<= 8;
	speed |= TL0;
	gotolcd(0x00); 
    sprintf(lcdbuf," speed %04d rps ",speed);
	printlcd();

   }
}


void interrupt timer1(void) 
{
  ms++;
  TH1  = 0xF3; 
  TL1  = 0xFF;
 return;
}


void printlcd(void)
{
 char i;
 char *p;
 
 p = lcdbuf;
 for(i = 0;i < 16;i++)
 {
    write_data(*p); 
    p++;
 }
 
 return;
}


void init_lcd(void)
{
  write_ins(0x33);
  write_ins(0x32);
  write_ins(0x28);
  write_ins(0x08);
  write_ins(0x01);
  write_ins(0x02);
  write_ins(0x0f);

 return;
}

void gotolcd(unsigned char i)
{
  i |= 0x80;

  write_ins(i); 
 
  return;
}

void write_ins(unsigned char i)
{
  
  P1 = i & 0xF0;
  E = 1;    delay(2);
  E = 0;    delay(2);

  P1 = (i << 4) & 0xF0;
  E = 1;   delay(2);
  E = 0;   delay(2);

 return;
}


void write_data(unsigned char i)
{
  
  P1 = (i & 0xF0) | 0x01;
  E = 1;    delay(2);
  E = 0;    delay(2);

  P1 = ((i << 4) & 0xF0) | 0x01;
  E = 1;    delay(2);
  E = 0;    delay(2);

 return;
}



void delay(char i)
{
  unsigned int j;

  do
  {
    for(j=0;j<1000;j++) {}
	i--; 
  }while(i > 0);

return;
}

